// Nick Marchuk
// 1/22/2010
// ME333 Motor Control
// To change the COM port, go to the InitSerial() function towards the bottom

// add the serial library
import processing.serial.*; 
Serial[] myPorts = new Serial[1];

// background image
PImage bg;

// general variables
int window_height = 480;
int window_width = 640;
int[] graph_data_1 = new int[window_width];
int[] graph_data_2 = new int[window_width];
int graph_index;

// buttons
ImageButtons button_p;
ImageButtons button_f;
ImageButtons button_b;
ImageButtons button_q;
ImageButtons button_w;

// setup runs once
void setup()
{
  frameRate(30);
  size(window_width,window_height);
  
  bg = loadImage("me333_lab4.jpg");
  background(bg);
  
  graph_index = 0;
  
  for(int i=0; i<window_width; i++) {
   graph_data_1[i] = 360;//int(25+12*sin(2*PI*0.01*i));
   graph_data_2[i] = 359;//int(50+25*sin(2*PI*0.01*i));
  }
  
  smooth();
  strokeWeight(4);
  
  // Define and create image button
  PImage b = loadImage("base_p.jpg");
  PImage r = loadImage("roll_p.jpg");
  PImage d = loadImage("down_p.jpg");
  int x = 20;
  int y = 375; 
  int w = b.width;
  int h = b.height;
  char c = 'p';
  button_p = new ImageButtons(x, y, w, h, b, r, d, c);
  
  // Define and create image button
  b = loadImage("base_f.jpg");
  r = loadImage("roll_f.jpg");
  d = loadImage("down_f.jpg");
  x = 125;
  y = 375; 
  w = b.width;
  h = b.height;
  c = 'f';
  button_f = new ImageButtons(x, y, w, h, b, r, d, c);
  
  // Define and create image button
  b = loadImage("base_b.jpg");
  r = loadImage("roll_b.jpg");
  d = loadImage("down_b.jpg");
  x = 230;
  y = 375; 
  w = b.width;
  h = b.height;
  c = 'b';
  button_b = new ImageButtons(x, y, w, h, b, r, d, c);
  
  // Define and create image button
  b = loadImage("base_q.jpg");
  r = loadImage("roll_q.jpg");
  d = loadImage("down_q.jpg");
  x = 315;
  y = 375; 
  w = b.width;
  h = b.height;
  c = 'q';
  button_q = new ImageButtons(x, y, w, h, b, r, d, c);
  
  // Define and create image button
  b = loadImage("base_w.jpg");
  r = loadImage("roll_w.jpg");
  d = loadImage("down_w.jpg");
  x = 400;
  y = 375; 
  w = b.width;
  h = b.height;
  c = 'w';
  button_w = new ImageButtons(x, y, w, h, b, r, d, c);
  
  // initialize the serial
  InitSerial();
}

void draw()
{
  
  background(bg);
  
  button_p.update();
  button_p.display();
  
  button_f.update();
  button_f.display();
  
  button_b.update();
  button_b.display();
  
  button_q.update();
  button_q.display();
  
  button_w.update();
  button_w.display();
  
  // encoder
  stroke(255, 0, 0);
  beginShape(LINES);
  for(int i=0; i<window_width; i++) {
   vertex(i, graph_data_1[i]);
  }
  endShape();
  
  // reference
  stroke(0, 255, 0);
  beginShape(LINES);
  for(int i=0; i<window_width; i++) {
   vertex(i, graph_data_2[i]);
  }
  endShape();
  
  //print(mouseX);
  //print(" ");
  //println(mouseY);
}

// initialize the serial port
void InitSerial() {
  // List all the available serial ports
  // you want the one that you plugged in
  println(Serial.list());

  String portList = Serial.list()[0];
  // this assumes the COM port you want is the first one, change the 0 to the place of your comport in the list that appears in the debug window
  myPorts[0] = new Serial(this, portList, 19200);

  // read bytes into a buffer until you get a linefeed (ASCII 10):
  myPorts[0].bufferUntil('\n');
}

// serial event, check which port generated the event, just in case there are more than 1 ports open
void serialEvent(Serial thisPort) { 
  // variable to hold the number of the port:
  int portNumber = -1;

  // iterate over the list of ports opened, and match the 
  // one that generated this event:
  for (int p = 0; p < myPorts.length; p++) {
    if (thisPort == myPorts[p]) {
      portNumber = p;
    }
  }

  // read the serial buffer until a newline appears
  String myString = thisPort.readStringUntil('\n');

  // if you got any bytes other than the newline
  if (myString != null) {

    myString = trim(myString); // ditch the newline

    // split the string at the spaces, save as integers
    int line_received[] = int(split(myString, ' '));

    // grab the data
    if ((line_received.length == 2)&&(portNumber==0)) {
      if (graph_index >= width) {
        graph_index = 0;
      }
      graph_data_1[graph_index] = int(map(line_received[0],-1000,1000,360,0));
      graph_data_2[graph_index] = int(map(line_received[1],-1000,1000,360,0));
      graph_index++;
    }
  }
} // end serialEvent

class Button
{
  int x, y;
  int w, h;
  color basecolor, highlightcolor;
  color currentcolor;
  boolean over = false;
  boolean pressed = false;   
  
  void pressed() {
    if(over && mousePressed) {
      pressed = true;
    } else {
      pressed = false;
    }    
  }
  
  boolean overRect(int x, int y, int width, int height) {
  if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) {
    return true;
  } else {
    return false;
  }
}
}

class ImageButtons extends Button 
{
  PImage base;
  PImage roll;
  PImage down;
  PImage currentimage;
  char send_char;

  ImageButtons(int ix, int iy, int iw, int ih, PImage ibase, PImage iroll, PImage idown, char isend_char) 
  {
    x = ix;
    y = iy;
    w = iw;
    h = ih;
    base = ibase;
    roll = iroll;
    down = idown;
    currentimage = base;
    send_char = isend_char;
  }
  
  void update() 
  {
    over();
    pressed();
    if(pressed) {
      currentimage = down;
      myPorts[0].write(send_char);
    } else if (over){
      currentimage = roll;
    } else {
      currentimage = base;
    }
  }
  
  void over() 
  {
    if( overRect(x, y, w, h) ) {
      over = true;
    } else {
      over = false;
    }
  }
  
  void display() 
  {
    image(currentimage, x, y);
  }
}

